// CreditVerification.h
#pragma once

#ifdef _DLL
#define DLLSPEC __declspec (dllexport)
#else
#define DLLSPEC __declspec (dllimport)
#endif

#define interface struct

interface IUnknown
{
       virtual long QueryInterface(IID& iid, void** pp) = 0;
       virtual long AddRef() = 0;
       virtual long Release() = 0;
};

interface ICreditVerification : IUnknown
{
	virtual void SetCardType(char* s) = 0;
	virtual bool VerifyCardNumber(long n) = 0;
};

DLLSPEC ICreditVerification* GetCreditVerificationObject();
