// TestCCV.cpp 
#include "stdafx.h"
#include "..\CreditVerification\CreditVerification.h"

int _tmain(int argc, _TCHAR* argv[])
{
	ICreditVerification* c = GetCreditVerificationObject();
	c->SetCardType("MasterCard");
	if (c->VerifyCardNumber(1234))
		MessageBox(0, "Card Verified", "OK", 0);
	else
		MessageBox(0, "Card Rejected", 0, 0);

	ISomethingElse* s;

	HRESULT hr = c->QueryInterface(IID_ISomethingElse, (void**)&s);
	if (FAILED(hr))
	{
		MessageBox(0, "QI failed", 0, 0);
		c->Release();
		return 1;
	}
	s->Foo();

	s->Release();
	c->Release();
	return 0;
}

