// CreditVerification.h
#pragma once

#ifdef _DLL
#define DLLSPEC __declspec (dllexport)
#else
#define DLLSPEC __declspec (dllimport)
#endif

#include <objbase.h> 

GUID IID_ICreditVerification = { 0xcbb27840, 0x836d, 0x11d1, 
{ 0xb9, 0x90, 0x0, 0x80, 0xc8, 0x24, 0xb3, 0x23 } };
 
GUID IID_ISomethingElse = { 0xd6925520, 0x8505, 0x11d1, 
{ 0xb9, 0x90, 0x0, 0x80, 0xc8, 0x24, 0xb3, 0x23 } };

GUID IID_ICreditVerification2 = { 0xd6925522, 0x8505, 0x11d1, 
{ 0xb9, 0x90, 0x0, 0x80, 0xc8, 0x24, 0xb3, 0x23 } };

interface ICreditVerification : IUnknown
{
	virtual void SetCardType(char* s) = 0;
	virtual bool VerifyCardNumber(long n) = 0;
};

interface ICreditVerification2 : ICreditVerification
{
	virtual char* GetCardType(int i) = 0;
};

interface ISomethingElse : IUnknown
{
	virtual void Foo() = 0;
};

DLLSPEC ICreditVerification* GetCreditVerificationObject();

/*
{01234567-1234-1234-1234-012345678ABC}
 
typedef struct GUIID
{
    unsigned long x;
    unsigned short s1;
    unsigned short s2;
    unsigned char c[8];
} GUID;
*/


